# @nuskin/foundation-themes

Nuskin themes to be used in the consuming project.

Supports dark mode
Provides NuskinThemeProvider to be used for theme change
Provides Utilities css classes provided by Tailwind css


## Installing

Usng npm:

```bash
npm add @nuskin/foundation-themes
```

Usng yarn:

```bash
yarn add @nuskin/foundation-themes
```

## Notes
can pass darkModeEnabled prop a false value to opt out of theme switch between light and dark mode

can get colors using ColorUtils.color
```
import { ColorUtils } from '@nuskin/foundation-theme';

const color = ColorUtils.color('primary', 'main')(validTheme);
```

can import theme json
````

import {nuskinTheme, forceForGoodTheme} from '@nuskin/foundation-theme';

```

## Example usage
```
import { NextGenThemeProvider, forceForGoodTheme, FoundationTheme } from '@nuskin/foundation-theme';
import Button from '@mui/material/Button';

export function App1(props) {
    const theme = useMemo(() => {
        if (props.theme === 'forceForGood') {
            return forceForGoodTheme;
        }
    }, props.theme);
    const { palette = {} } = theme || {};
    const colorVariables = Object.keys(palette) as FoundationTheme.PaletteColors[];
    return (
        <NextGenThemeProvider isSSR cacheKey="app" theme={theme}>
            {colorVariables?.map((color, index) => (
                <Button variant="contained" color={color} key={color + index}>
                    Nuskin button + { " " + index}
                </Button>
            ))}
        </NextGenThemeProvider>
    );
}
```

## release versions

https://www.npmjs.com/package/@nuskin/foundation-theme?activeTab=versions

# latest release
1.0.0-develop.5

## Resources

- Changelog could go here

## License

[MIT](https://opensource.org/licenses/MIT)