/* eslint-disable no-unused-vars */
import {
    CommonColors,
    Palette,
    PaletteAugmentColorOptions,
    PaletteColorOptions,
    PaletteTonalOffset,
    TypeAction,
    TypeBackground,
    TypeDivider,
    TypeText,
} from '@mui/material/styles/createPalette';
import { CSSProperties } from 'react';

import { Colors, FoundationTheme } from './themes';
import { GenomeColorType } from './themes/genome-colors/AllColors';

import '@mui/material/Button';
import '@mui/material/Button';
import '@mui/material/styles';
/* eslint-disable no-unused-vars */

import '@mui/material/styles';
import '@mui/material/Typography';
import '@mui/material/Typography';

declare module '@emotion/react' {
    export interface Theme {
        palette: Palette;
        colors?: FoundationTheme.Colors;
        config?: FoundationTheme.ThemeConfig;
    }
}

declare module '@mui/material/styles' {
    interface Theme {
        colors?: FoundationTheme.Colors;
        config?: FoundationTheme.ThemeConfig;
        genomeColors?: GenomeColorType;
    }

    interface PaletteColor {
        dark?: PaletteOptions;
        light?: PaletteOptions;
        buttonState?: FoundationTheme.ButtonState;
        darkMode?: Palette['primary'] & FoundationTheme.ButtonState;
    }

    interface Palette {
        primary: PaletteColor;
        neutral?: PaletteColor;
        secondary?: PaletteColor;
        accentColorA?: PaletteColor;
        accentColorB?: PaletteColor;
        accentColorC?: PaletteColor;
        accentColorD?: PaletteColor;
        success?: PaletteColor;
        warning?: PaletteColor;
        error?: PaletteColor;
        info?: PaletteColor;
        contrastThreshold?: number;
        tonalOffset?: number;
        common?: CommonColors;
        mode?: FoundationTheme.Theme;
        contrastThreshold?: number;
        tonalOffset?: PaletteTonalOffset;
        grey?: PaletteColor;
        text?: TypeText;
        divider?: TypeDivider;
        action?: TypeAction;
        background?: TypeBackground;
        getContrastText?: (background: string) => string;
        augmentColor?: (options: PaletteAugmentColorOptions) => PaletteColor;
    }
    type PaletteKeys = keyof Palette;
    interface PaletteOptions {
        neutral?: PaletteColor;
        secondary?: PaletteColor;
        accentColorA?: PaletteColor;
        accentColorB?: PaletteColor;
        accentColorC?: PaletteColor;
        accentColorD?: PaletteColor;
        success?: PaletteColor;
        warning?: PaletteColor;
        error?: PaletteColor;
        info?: PaletteColor;
    }
}

declare module '@mui/material/Button' {
    // Update the Button's color prop options
    interface ButtonPropsColorOverrides {
        neutral: true;
        accentColorA: true;
        accentColorB: true;
        accentColorC: true;
        accentColorD: true;
        inherit: false;
    }
}

declare module '@mui/material/SvgIcon' {
    interface SvgIconPropsColorOverrides {
        neutral: true;
        accentColorA: true;
        accentColorB: true;
        accentColorC: true;
        accentColorD: true;
    }
}
