import { LightDarkColorType } from './types';
import { mixColors } from './util';

export type AccentAColorNameType = 'A100' | 'A90' | 'A80' | 'A70' | 'A60' | 'A50' | 'A40' | 'A30' | 'A20' | 'A10';

export const createAccentAColors = (): Record<AccentAColorNameType, LightDarkColorType> => {
    const base: Record<AccentAColorNameType, string> = {
        A100: '#14324F',
        A90: '#314E72',
        A80: '#4D6995',
        A70: '#677FA5',
        A60: '#8196B5',
        A50: '#9AACC4',
        A40: '#B4C3D4',
        A30: '#CED9E4',
        A20: '#DAE3ED',
        A10: '#E5EDF6',
    };
    return mixColors(base, 'A');
};
/*
export const AccentA = {
    "A10": {
        "light": "#E5EDF6",
        "dark": "#14324F"
    },
    "A20": {
        "light": "#DAE3ED",
        "dark": "#314E72"
    },
    "A30": {
        "light": "#CED9E4",
        "dark": "#4D6995"
    },
    "A40": {
        "light": "#B4C3D4",
        "dark": "#677FA5"
    },
    "A50": {
        "light": "#9AACC4",
        "dark": "#8196B5"
    },
    "A60": {
        "light": "#8196B5",
        "dark": "#9AACC4"
    },
    "A70": {
        "light": "#677FA5",
        "dark": "#B4C3D4"
    },
    "A80": {
        "light": "#4D6995",
        "dark": "#CED9E4"
    },
    "A90": {
        "light": "#314E72",
        "dark": "#DAE3ED"
    },
    "A100": {
        "light": "#14324F",
        "dark": "#E5EDF6"
    }
};
 */
