import { LightDarkColorType } from './types';
import { mixColors } from './util';
export type AccentCColorNameType = 'C100' | 'C90' | 'C80' | 'C70' | 'C60' | 'C50' | 'C40' | 'C30' | 'C20' | 'C10';

export const createAccentCColors = (): Record<AccentCColorNameType, LightDarkColorType> => {
    const paletteBase = {
        C100: '#405E50', // hsla(152, 19%, 31%, 1)
        C90: '#4D7160', // hsla(152, 19%, 37%, 1)
        C80: '#5B8571', // hsla(151, 19%, 44%, 1) (Text)
        C70: '#689881', // hsla(151, 19%, 50%, 1) (AP24 Green)
        C60: '#7BA58F', // hsla(149, 19%, 56%, 1)
        C50: '#8DB39C', // hsla(144, 20%, 63%, 1)
        C40: '#A0C0AA', // hsla(139, 20%, 69%, 1)  (Brand Primary)
        C30: '#B2CDB7', // hsla(131, 21%, 75%, 1)
        C20: '#C5DBC5', // hsla(120, 23%, 82%, 1)
        C10: '#D7E8D2', // hsla(106, 32%, 87%, 1)(Brand Accent)
    };

    return mixColors(paletteBase, 'C');
};
/*
const base = {
    C100: '#044F44',
    C90: '#036D5D',
    C80: '#018C77', //  (Text)
    C70: '#00AA90', //  (AP24 Green)
    C60: '#34A997',
    C50: '#68A89E',
    C40: '#9CA7A5', //  (Brand Primary)
    C30: '#C4CAC9',
    C20: '#EBEDED',
    C10: '#E3E5D6', // (Brand Accent)
};
export const AccentC = {
    C10: {
        light: '#D7E8D2',
        dark: '#405E50',
    },
    C20: {
        light: '#C5DBC5',
        dark: '#4D7160',
    },
    C30: {
        light: '#B2CDB7',
        dark: '#5B8571',
    },
    C40: {
        light: '#A0C0AA',
        dark: '#689881',
    },
    C50: {
        light: '#8DB39C',
        dark: '#7BA58F',
    },
    C60: {
        light: '#7BA58F',
        dark: '#8DB39C',
    },
    C70: {
        light: '#689881',
        dark: '#A0C0AA',
    },
    C80: {
        light: '#5B8571',
        dark: '#B2CDB7',
    },
    C90: {
        light: '#4D7160',
        dark: '#C5DBC5',
    },
    C100: {
        light: '#405E50',
        dark: '#D7E8D2',
    },
};
 */
