import { LightDarkColorType } from './types';
import { mixColors } from './util';
export type AccentEColorNameType = 'E100' | 'E90' | 'E80' | 'E70' | 'E60' | 'E50' | 'E40' | 'E30' | 'E20' | 'E10';

export const createAccentEColors = (): Record<AccentEColorNameType, LightDarkColorType> => {
    const paletteBase = {
        E100: '#41396C', // hsla(249, 31%, 32%, 1)
        E90: '#534A83', // hsla(249, 28%, 40%, 1)
        E80: '#655B9A', // hsla(250, 26%, 48%, 1) (Text)
        E70: '#776CB1', // hsla(250, 31%, 56%, 1) (AP24 Green)
        E60: '#9188BF', // hsla(250, 30%, 64%, 1)
        E50: '#AAA3CD', // hsla(250, 30%, 72%, 1)
        E40: '#C4BFDA', // hsla(251, 27%, 80%, 1)  (Brand Primary)
        E30: '#DDDAE8', // hsla(253, 23%, 88%, 1)
        E20: '#F0EFF5', // hsla(250, 23%, 95%, 1)
        E10: '#F8F7FA', // hsla(260, 23%, 97%, 1)(Brand Accent)
    };

    return mixColors(paletteBase, 'E');
};
/*
export const base = {
    E100: '#392671',
    E90: '#7965B2', //(Nutricentials Purple)
    E80: '#8072AD',
    E70: '#877FA8',
    E60: '#8E8CA3', // (Brand Primary)
    E50: '#A5A3B5',
    E40: '#BBBAC8',
    E30: '#CDD1DE', // (Brand Accent)
    E20: '#E8E8ED',
    E10: '#F2F0F7',
};
export const AccentE = {
    E10: {
        light: '#F8F7FA',
        dark: '#41396C',
    },
    E20: {
        light: '#F0EFF5',
        dark: '#534A83',
    },
    E30: {
        light: '#DDDAE8',
        dark: '#655B9A',
    },
    E40: {
        light: '#C4BFDA',
        dark: '#776CB1',
    },
    E50: {
        light: '#AAA3CD',
        dark: '#9188BF',
    },
    E60: {
        light: '#9188BF',
        dark: '#AAA3CD',
    },
    E70: {
        light: '#776CB1',
        dark: '#C4BFDA',
    },
    E80: {
        light: '#655B9A',
        dark: '#DDDAE8',
    },
    E90: {
        light: '#534A83',
        dark: '#F0EFF5',
    },
    E100: {
        light: '#41396C',
        dark: '#F8F7FA',
    },
};
 */
