import { LightDarkColorType } from './types';
import { mixColors } from './util';
export type InfoColorNameType =
    | 'Info-100'
    | 'Info-90'
    | 'Info-80'
    | 'Info-70'
    | 'Info-60'
    | 'Info-50'
    | 'Info-40'
    | 'Info-30'
    | 'Info-20'
    | 'Info-10';

export const createInfoColors = (): Record<InfoColorNameType, LightDarkColorType> => {
    const base: Record<InfoColorNameType,string> = {
        'Info-100': '#1C425D', // hsla(205, 54%, 24%, 1)
        'Info-90': '#25577B', // hsla(205, 54%, 31%, 1)
        'Info-80': '#2E6D9A', // hsla(205, 54%, 39%, 1)
        'Info-70': '#3378AA', // hsla(205, 54%, 43%, 1)
        'Info-60': '#3783B9', // hsla(205, 54%, 47%, 1)
        'Info-50': '#5998C5', // hsla(205, 48%, 56%, 1)
        'Info-40': '#7AACD0', // hsla(205, 48%, 65%, 1)
        'Info-30': '#A4C7E0', // hsla(205, 49%, 76%, 1)
        'Info-20': '#CEE1EF', // hsla(205, 51%, 87%, 1)
        'Info-10': '#F8FCFF', // hsla(206, 100%, 99%, 1)
    };
    return mixColors(base, 'Info-');
};
/* export const info = {
    'Info-10': {
        light: '#F8FCFF',
        dark: '#1C425D',
    },
    'Info-20': {
        light: '#CEE1EF',
        dark: '#25577B',
    },
    'Info-30': {
        light: '#A4C7E0',
        dark: '#2E6D9A',
    },
    'Info-40': {
        light: '#7AACD0',
        dark: '#3378AA',
    },
    'Info-50': {
        light: '#5998C5',
        dark: '#3783B9',
    },
    'Info-60': {
        light: '#3783B9',
        dark: '#5998C5',
    },
    'Info-70': {
        light: '#3378AA',
        dark: '#7AACD0',
    },
    'Info-80': {
        light: '#2E6D9A',
        dark: '#A4C7E0',
    },
    'Info-90': {
        light: '#25577B',
        dark: '#CEE1EF',
    },
    'Info-100': {
        light: '#1C425D',
        dark: '#F8FCFF',
    },
}; */
