import { LightDarkColorType } from './types';
import { createFromLightDarkBase } from './util';

export type LumiSpaColorNameType =
    | 'Lumi-Primary-A'
    | 'Lumi-Primary-B'
    | 'Lumi-Secondary-A'
    | 'Lumi-Secondary-Grey'
    | 'Lumi-Secondary-C';
export const createLumiColors = (): Record<LumiSpaColorNameType, LightDarkColorType> => {
    const base: Record<LumiSpaColorNameType, string> = {
        'Lumi-Primary-A': '#99D6EA',
        'Lumi-Primary-B': '#69B3E7',
        'Lumi-Secondary-A': '#BB29BB',
        'Lumi-Secondary-Grey': '#75787B',
        'Lumi-Secondary-C': '#C7EBF2',
    };
    const darkBase: Record<LumiSpaColorNameType, string> = {
        'Lumi-Primary-A': '#273539',
        'Lumi-Primary-B': '#0B1F2E',
        'Lumi-Secondary-A': '#4F104F',
        'Lumi-Secondary-Grey': '#8A8F94',
        'Lumi-Secondary-C': '#021B20',
    };
    return createFromLightDarkBase(base, darkBase);
};
/*
export const LumiColors = {
    'Lumi-Primary-A': {
        light: '#99D6EA',
        dark: '#273539',
    },
    'Lumi-Primary-B': {
        light: '#69B3E7',
        dark: '#0B1F2E',
    },
    'Lumi-Secondary-A': {
        light: '#BB29BB',
        dark: '#4F104F',
    },
    'Lumi-Secondary-Grey': {
        light: '#75787B',
        dark: '#8A8F94',
    },
    'Lumi-Secondary-C': {
        light: '#C7EBF2',
        dark: '#021B20',
    },
}; */
