import { LightDarkColorType } from './types';
import { mixColors } from './util';
export type SuccessColorNameType =
    | 'Success-100'
    | 'Success-90'
    | 'Success-80'
    | 'Success-70'
    | 'Success-60'
    | 'Success-50'
    | 'Success-40'
    | 'Success-30'
    | 'Success-20'
    | 'Success-10';

export const createSuccessColors = (): Record<SuccessColorNameType, LightDarkColorType> => {
    const paletteBase: Record<SuccessColorNameType, string> = {
        'Success-100': '#066100', // hsla(116, 100%, 19%, 1)
        'Success-90': '#0D870D', // hsla(120, 82%, 29%, 1)
        'Success-80': '#2C9B2B', // hsla(119, 57%, 39%, 1)
        'Success-70': '#4AAE49', // hsla(119, 41%, 48%, 1)
        'Success-60': '#6BC56A', // hsla(119, 44%, 59%, 1)
        'Success-50': '#7BCF7B', // hsla(120, 47%, 65%, 1)
        'Success-40': '#8CD88B', // hsla(119, 50%, 70%, 1)
        'Success-30': '#9CE29C', // hsla(120, 55%, 75%, 1)
        'Success-20': '#C4F1C4', // hsla(120, 62%, 86%, 1)
        'Success-10': '#F3FFF9', // hsla(150, 100%, 98%, 1)
    };
    return mixColors(paletteBase, 'Success-');
};
/* const base = {
    'Success-100': '#066100',
    'Success-90': '#0D870D', // (Pressed)
    'Success-80': '#2C9B2B',
    'Success-70': '#4AAE49', // (Hover)
    'Success-60': '#6BC56A', // (Main)
    'Success-50': '#7BCF7B',
    'Success-40': '#8CD88B',
    'Success-30': '#9CE29C', // (Border)
    'Success-20': '#C4F1C4',
    'Success-10': '#F3FFF9', // (Background)
};

export const success = {
    'Success-10': {
        light: '#F3FFF9',
        dark: '#066100',
    },
    'Success-20': {
        light: '#C4F1C4',
        dark: '#0D870D',
    },
    'Success-30': {
        light: '#9CE29C',
        dark: '#2C9B2B',
    },
    'Success-40': {
        light: '#8CD88B',
        dark: '#4AAE49',
    },
    'Success-50': {
        light: '#7BCF7B',
        dark: '#6BC56A',
    },
    'Success-60': {
        light: '#6BC56A',
        dark: '#7BCF7B',
    },
    'Success-70': {
        light: '#4AAE49',
        dark: '#8CD88B',
    },
    'Success-80': {
        light: '#2C9B2B',
        dark: '#9CE29C',
    },
    'Success-90': {
        light: '#0D870D',
        dark: '#C4F1C4',
    },
    'Success-100': {
        light: '#066100',
        dark: '#F3FFF9',
    },
};
 */
