import { LightDarkColorType } from './types';
import { createFromLightDarkBase } from './util';

export type WellSpaColorNameType =
    | 'Well-Primary-A'
    | 'Well-Primary-B'
    | 'Well-Secondary-A'
    | 'Well-Secondary-B'
    | 'Well-Secondary-C'
    | 'Well-ProgressBlue'
    | 'Well-LightBlueBG';
export const createWellColors = (): Record<WellSpaColorNameType, LightDarkColorType> => {
    const base: Record<WellSpaColorNameType, string> = {
        'Well-Primary-A': '#647692',
        'Well-Primary-B': '#98A4AE',
        'Well-Secondary-A': '#B9C9CC',
        'Well-Secondary-B': '#D9D9D6',
        'Well-Secondary-C': '#B1C0BC',
        'Well-ProgressBlue': '#A3DBFB',
        'Well-LightBlueBG': '#F1F5F9',
    };
    const darkBase: Record<WellSpaColorNameType, string> = {
        'Well-Primary-A': '#3E4A5C',
        'Well-Primary-B': '#464C51',
        'Well-Secondary-A': '#3A4142',
        'Well-Secondary-B': '#303030',
        'Well-Secondary-C': '#373E3C',
        'Well-ProgressBlue': '#A3DBFB',
        'Well-LightBlueBG': '#191F25',
    };
    return createFromLightDarkBase(base, darkBase);
};

/* export const WellColors = {
    {
    "Well-Primary-A": {
        "light": "#647692",
        "dark": "#3E4A5C"
    },
    "Well-Primary-B": {
        "light": "#98A4AE",
        "dark": "#464C51"
    },
    "Well-Secondary-A": {
        "light": "#B9C9CC",
        "dark": "#3A4142"
    },
    "Well-Secondary-B": {
        "light": "#D9D9D6",
        "dark": "#303030"
    },
    "Well-Secondary-C": {
        "light": "#B1C0BC",
        "dark": "#373E3C"
    },
    "Well-ProgressBlue": {
        "light": "#A3DBFB",
        "dark": "#A3DBFB"
    },
    "Well-LightBlueBG": {
        "light": "#F1F5F9",
        "dark": "#191F25"
    }
}
};
 */
