import { createAccentBColors } from '../AccentB';

describe('AccentB', () => {
    it('1. should match dark and light color keys', () => {
        const colors = createAccentBColors();
        for (let lightDarkColor of Object.values(colors)) {
            expect(lightDarkColor.light).toHaveLength(7);
            expect(lightDarkColor.dark).toHaveLength(7);
        }
    });
    it('2. should return the correct object', () => {
        const result = createAccentBColors();
        expect(result).toEqual({
            B10: {
                light: '#F4EEEF',
                dark: '#641034',
            },
            B20: {
                light: '#F5E6E5',
                dark: '#7F2845',
            },
            B30: {
                light: '#F5DEDA',
                dark: '#9A4056',
            },
            B40: {
                light: '#E8B9B9',
                dark: '#B45766',
            },
            B50: {
                light: '#DC9498',
                dark: '#CF6F77',
            },
            B60: {
                light: '#CF6F77',
                dark: '#DC9498',
            },
            B70: {
                light: '#B45766',
                dark: '#E8B9B9',
            },
            B80: {
                light: '#9A4056',
                dark: '#F5DEDA',
            },
            B90: {
                light: '#7F2845',
                dark: '#F5E6E5',
            },
            B100: {
                light: '#641034',
                dark: '#F4EEEF',
            },
        });
    });
});
