import { createErrorColors } from '../ErrorColors';

describe('Error', () => {
    it('1. should match dark and light color keys', () => {
        const colors = createErrorColors();
        for (let lightDarkColor of Object.values(colors)) {
            expect(lightDarkColor.light).toHaveLength(7);
            expect(lightDarkColor.dark).toHaveLength(7);
        }
    });
    it('2. should return the correct object', () => {
        const result = createErrorColors();
        expect(result).toEqual({
            'Error-10': {
                light: '#FFEFEF',
                dark: '#510B0E',
            },
            'Error-20': {
                light: '#F0C6C7',
                dark: '#8E0009',
            },
            'Error-30': {
                light: '#E19D9F',
                dark: '#AC040E',
            },
            'Error-40': {
                light: '#D17376',
                dark: '#BA1116',
            },
            'Error-50': {
                light: '#C24A4E',
                dark: '#C81D1D',
            },
            'Error-60': {
                light: '#C81D1D',
                dark: '#C24A4E',
            },
            'Error-70': {
                light: '#BA1116',
                dark: '#D17376',
            },
            'Error-80': {
                light: '#AC040E',
                dark: '#E19D9F',
            },
            'Error-90': {
                light: '#8E0009',
                dark: '#F0C6C7',
            },
            'Error-100': {
                light: '#510B0E',
                dark: '#FFEFEF',
            },
        });
    });
});
