import { createInfoColors } from '../InfoColors';

describe('Info', () => {
    it('1. should match dark and light color keys', () => {
        const colors = createInfoColors();
        for (let lightDarkColor of Object.values(colors)) {
            expect(lightDarkColor.light).toHaveLength(7);
            expect(lightDarkColor.dark).toHaveLength(7);
        }
    });
    it('2. should return the correct object', () => {
        const result = createInfoColors();
        expect(result).toEqual({
            'Info-10': {
                light: '#F8FCFF',
                dark: '#1C425D',
            },
            'Info-20': {
                light: '#CEE1EF',
                dark: '#25577B',
            },
            'Info-30': {
                light: '#A4C7E0',
                dark: '#2E6D9A',
            },
            'Info-40': {
                light: '#7AACD0',
                dark: '#3378AA',
            },
            'Info-50': {
                light: '#5998C5',
                dark: '#3783B9',
            },
            'Info-60': {
                light: '#3783B9',
                dark: '#5998C5',
            },
            'Info-70': {
                light: '#3378AA',
                dark: '#7AACD0',
            },
            'Info-80': {
                light: '#2E6D9A',
                dark: '#A4C7E0',
            },
            'Info-90': {
                light: '#25577B',
                dark: '#CEE1EF',
            },
            'Info-100': {
                light: '#1C425D',
                dark: '#F8FCFF',
            },
        });
    });
});
