import { createRenuColors } from '../RenuSpa';

describe('Renu', () => {
    it('1. should match dark and light color keys', () => {
        const colors = createRenuColors();
        for (let lightDarkColor of Object.values(colors)) {
            expect(lightDarkColor.light).toHaveLength(7);
            expect(lightDarkColor.dark).toHaveLength(7);
        }
    });
    it('2. should return the correct object', () => {
        const result = createRenuColors();
        expect(result).toEqual({
            'Renu-Primary-A': {
                light: '#726477',
                dark: '#88788E',
            },
            'Renu-Primary-B': {
                light: '#ADA4AE',
                dark: '#4C484D',
            },
            'Renu-Secondary-A': {
                light: '#DEDBDF',
                dark: '#282828',
            },
            'Renu-Secondary-B': {
                light: '#DFDCDB',
                dark: '#282827',
            },
            'Renu-Secondary-C': {
                light: '#DADDDE',
                dark: '#2D2D2E',
            },
            'Renu-NewPurple': {
                light: '#C3A4F4',
                dark: '#15121B',
            },
            'Renu-LightPurpleBG': {
                light: '#F2F0F7',
                dark: '#111112',
            },
        });
    });
});
