import { createWellColors } from '../WellSpa';

describe('Well', () => {
    it('1. should match dark and light color keys', () => {
        const colors = createWellColors();
        for (let lightDarkColor of Object.values(colors)) {
            expect(lightDarkColor.light).toHaveLength(7);
            expect(lightDarkColor.dark).toHaveLength(7);
        }
    });
    it('2. should return the correct object', () => {
        const result = createWellColors();
        expect(result).toEqual({
            'Well-Primary-A': {
                light: '#647692',
                dark: '#3E4A5C',
            },
            'Well-Primary-B': {
                light: '#98A4AE',
                dark: '#464C51',
            },
            'Well-Secondary-A': {
                light: '#B9C9CC',
                dark: '#3A4142',
            },
            'Well-Secondary-B': {
                light: '#D9D9D6',
                dark: '#303030',
            },
            'Well-Secondary-C': {
                light: '#B1C0BC',
                dark: '#373E3C',
            },
            'Well-ProgressBlue': {
                light: '#A3DBFB',
                dark: '#A3DBFB',
            },
            'Well-LightBlueBG': {
                light: '#F1F5F9',
                dark: '#191F25',
            },
        });
    });
});
